#ifndef debug_client_h
#define debug_client_h

#include <stdlib.h>
#include <Messenger.h>
#include <String.h>

class DebugClient 
{
	// BMessager to our DebugMonitor server application
	BMessenger server;
	
	// Holds the client application signature so we don't have to 
	// get it every time
	BString signature;
	
	// Gets the app signature unless already available
	void GetSignature(void);
	// Stuffs basic information into message
	void GetBasicInfo(BMessage *message);
	
public:
	DebugClient();
	
	void handletrace(const char *message, 
			const char *file,
			const unsigned int line,
			const char *function);

	void handleassertfail(const char *assertion,
			const char *file,
			const unsigned int line,
			const char *function);
};

#ifndef NDEBUG

extern DebugClient debug;

#define assert(expr)							      	\
  ((void) ((expr) ? 0 :							      	\
	   (debug.handleassertfail(__STRING(expr),		    \
			__FILE__, __LINE__, __PRETTY_FUNCTION__), 0)))
			   
#define trace(msg)										\
  ((void) debug.handletrace(msg, 						\
  			__FILE__, __LINE__, __PRETTY_FUNCTION__))
  
#else

#define assert(expr)	((void)0)
#define trace(msg)		((void)0)  
  
#endif


#endif